fun_0(n)={
   local(a,b);
   a=vector(n);b=vector(n);
   a[1]=0.5;
   for(s=1,floor((n-1)/2),
      for(k=0,s-1,
         b[2*s]+=a[2*k+1]*a[2*s-2*k-1]
      );
      a[2*s+1]=b[2*s];
      for(k=1,s,
         a[2*s+1]-=b[2*k]*a[2*s-2*k+1]
      );
      a[2*s+1]/=2*s+2
   );
   a
}

fun(a0,h,n)={
   local(a,b,b0);
   a=vector(n);b=vector(n);
   b0=a0*a0;
      a[1]=(h-a0)*(1+b0)/h;
      b[1]=2.0*a0*a[1];
      a[2]=((h-a0)*b[1]+(1-a[1])*(1+b0)-a[1])/(2.0*h);
      b[2]=2*a0*a[2]+a[1]^2;
      for(s=3,n,
          a[s]=(h-a0)*b[s-1]+1*b[s-2];
          a[s]-=(s+b0)*a[s-1];
          for(t=1,s-2,a[s]-=b[t]*a[s-1-t]);
          a[s]/=s*h;
          b[s]=2*a0*a[s];
          for(t=1,s-1,b[s]+=a[t]*a[s-t])
      );
   a
}

array_to_taylor(a0,a)={
    local(l,s);
    l=length(a);s=a0;
    for(u=1,l,s+=a[u]*x^u);
    s+=O(x^(l+1));
    s
}

taylor_to_array(s, n)={
    local(a0,a);
    a0=polcoeff(s,0);
    a=vector(n);
    for(u=1,n,a[u]=polcoeff(s,u));
    [a0,a]
}

use_fun(a0,h,a,x)={
    local(y,s,l);
    y=x-h;s=0.0;l=length(a);
    for(u=1,l,
        s*=y;s+=a[l+1-u];
    );
    s*=y;s+=a0;
    s
}

use_dfun(h,a,x)={
    local(y,s,l);
    y=x-h;s=0.0;l=length(a);
    for(u=1,l,s*=y;s+=(l+1-u)*a[l+1-u]);
    s
}

gen_v_params(n)={
   local(a,a0,b,b0,c,c0,d,d0,e,e0,f,f0,g,g0,h,h0,m,m0,k);
   a=fun_0(n);
   a0=use_fun(0.0,0.0,a,0.5);
   b=fun(a0,0.5,n);
   b0=use_fun(a0,0.5,b,1.0);
   c=fun(b0,1.0,n);
   c0=use_fun(b0,1.0,c,1.7);
   d=fun(c0,1.7,n);
   d0=use_fun(c0,1.7,d,2.2);
   e=fun(d0,2.2,n);
   e0=use_fun(d0,2.2,e,2.6);
   f=fun(e0,2.6,n);
   f0=use_fun(e0,2.6,f,3.0);
   g=fun(f0,3.0,n);
   g0=use_fun(f0,3.0,g,3.5);
   h=fun(g0,3.5,n);
   h0=use_fun(g0,3.5,h,4.2);
   m=fun(h0,4.2,n);
   m0=use_fun(h0,4.2,m,5.0);
   k=fun(m0,5.0,n);
   [a,a0,b,b0,c,c0,d,d0,e,e0,f,f0,g,g0,h,h0,m,m0,k]
}

gen_V_params(v_params)={
    local(a,a0,b,b0,c,c0,d,d0,e,e0,f,f0,g,g0,h,h0,m,m0,k);
    a=v_to_V(1.0,0.0,v_params[1]);
    a0=use_fun(1.0,0.0,a,0.5);
    b=v_to_V(a0,v_params[2],v_params[3]); 
    b0=use_fun(a0, 0.5,b,1.0);
    c=v_to_V(b0,v_params[4],v_params[5]); 
    c0=use_fun(b0, 1.0,c,1.7);
    d=v_to_V(c0,v_params[6],v_params[7]); 
    d0=use_fun(c0, 1.7,d,2.2);
    e=v_to_V(d0,v_params[8],v_params[9]); 
    e0=use_fun(d0, 2.2,e,2.6);
    f=v_to_V(e0,v_params[10],v_params[11]); 
    f0=use_fun(e0, 2.6,f,3.0);
   g=v_to_V(f0,v_params[12],v_params[13]); 
   g0=use_fun(f0,3.0,g,3.5);
   h=v_to_V(g0,v_params[14],v_params[15]); 
   h0=use_fun(g0,3.5,h,4.2);
   m=v_to_V(h0,v_params[16],v_params[17]); 
   m0=use_fun(h0,4.2,m,5.0);
   k=v_to_V(m0,v_params[18],v_params[19]); 
   [a,a0,b,b0,c,c0,d,d0,e,e0,f,f0,g,g0,h,h0,m,m0,k]
}

gen_u_params(v_params,d)={
   local(n,a0,b,b0,c,c0,dd,d0,e,e0,f,f0,g,g0,h,h0,m,m0,k);
   n=length(v_params[1]);
   e=2*Pi-2*d;
   a0=fun_v(v_params,e);a=fun(a0,e,n);
   b=gen_u_from_v(tan(d),a0,a);m0=use_fun(tan(d),e,b,5.0);
   k=gen_u_from_v(m0,v_params[18],v_params[19]);
   h0=use_fun(m0,5.0,k,4.2);
   m=gen_u_from_v(h0,v_params[16],v_params[17]);
   g0=use_fun(h0,4.2,m,3.5);
   h=gen_u_from_v(g0,v_params[14],v_params[15]);
   f0=use_fun(g0,3.5,h,3.0);
   g=gen_u_from_v(f0,v_params[12],v_params[13]);
   e0=use_fun(f0,3.0,g,2.6);
   f=gen_u_from_v(e0,v_params[10],v_params[11]);
   d0=use_fun(e0,2.6,f,2.2);
   e=gen_u_from_v(d0,v_params[8],v_params[9]);
   c0=use_fun(d0,2.2,e,1.7);
   dd=gen_u_from_v(c0,v_params[6],v_params[7]);
   b0=use_fun(c0,1.7,dd,1.0);
   c=gen_u_from_v(b0,v_params[4],v_params[5]);
   a0=use_fun(b0,1.0,c,0.5);
   b=gen_u_from_v(a0,v_params[2],v_params[3]);
   [a0,b,b0,c,c0,dd,d0,e,e0,f,f0,g,g0,h,h0,m,m0,k]
}

gen_B_params(v_param,u_param)={
    local(n,a0,b,b0,c,c0,dd,d0,e,e0,f,f0,g,g0,h,h0,m,m0,k);
    n=length(v_param[1]);
    b=uv_to_BD(0.5, u_param[1],v_param[2],u_param[2],v_param[3]);
    a0=-use_fun(0.0,0.5,b,0.0);
    b0=use_fun(a0,0.5,b,1.0);
    c=uv_to_BD(1.0, u_param[3],v_param[4],u_param[4],v_param[5]);
    c0=use_fun(b0,1.0,c,1.7);
    dd=uv_to_BD(1.7, u_param[5],v_param[6],u_param[6],v_param[7]);
    d0=use_fun(c0,1.7,dd,2.2);
    e=uv_to_BD(2.2, u_param[7],v_param[8],u_param[8],v_param[9]);
    e0=use_fun(d0,2.2,e,2.6);
    f=uv_to_BD(2.6, u_param[9],v_param[10],u_param[10],v_param[11]);
    f0=use_fun(e0,2.6,f,3.0);
    g=uv_to_BD(3.0, u_param[11],v_param[12],u_param[12],v_param[13]);
    g0=use_fun(f0,3.0,g,3.5);
    h=uv_to_BD(3.5, u_param[13],v_param[14],u_param[14],v_param[15]);
    h0=use_fun(g0,3.5,h,4.2);
    m=uv_to_BD(4.2, u_param[15],v_param[16],u_param[16],v_param[17]);
    m0=use_fun(h0,4.2,m,5.0);
    k=uv_to_BD(5.0, u_param[17],v_param[18],u_param[18],v_param[19]);
    [a0,b,b0,c,c0,dd,d0,e,e0,f,f0,g,g0,h,h0,m,m0,k]
}

gen_D_params(v_param,V_param)={
    local(n,a0,b,b0,c,c0,dd,d0,e,e0,f,f0,g,g0,h,h0,m,m0,k);
    n=length(v_param[1]);
    b=uv_to_BD(0.5, V_param[2],v_param[2],V_param[3],v_param[3]);
    a0=-use_fun(0.0,0.5,b,0.0);
    b0=use_fun(a0,0.5,b,1.0);
    c=uv_to_BD(1.0, V_param[4],v_param[4],V_param[5],v_param[5]);
    c0=use_fun(b0,1.0,c,1.7);
    dd=uv_to_BD(1.7, V_param[6],v_param[6],V_param[7],v_param[7]);
    d0=use_fun(c0,1.7,dd,2.2);
    e=uv_to_BD(2.2, V_param[8],v_param[8],V_param[9],v_param[9]);
    e0=use_fun(d0,2.2,e,2.6);
    f=uv_to_BD(2.6, V_param[10],v_param[10],V_param[11],v_param[11]);
    f0=use_fun(e0,2.6,f,3.0);
    g=uv_to_BD(3.0, V_param[12],v_param[12],V_param[13],v_param[13]);
    g0=use_fun(f0,3.0,g,3.5);
    h=uv_to_BD(3.5, V_param[14],v_param[14],V_param[15],v_param[15]);
    h0=use_fun(g0,3.5,h,4.2);
    m=uv_to_BD(4.2, V_param[16],v_param[16],V_param[17],v_param[17]);
    m0=use_fun(h0,4.2,m,5.0);
    k=uv_to_BD(5.0, V_param[18],v_param[18],V_param[19],v_param[19]);
    [a0,b,b0,c,c0,dd,d0,e,e0,f,f0,g,g0,h,h0,m,m0,k]
}

uv_to_BD(init,u0,v0,u,v)={
    local(s1,s2,n);
    n=length(v);
    s1=array_to_taylor(v0,v);
    s2=array_to_taylor(u0,u);
    s2=s2*sqrt(1+s1^2)*(x+init);
    s2=intformal(s2);
    taylor_to_array(s2,n+1)[2]
}

gen_u_from_v(u0,v0,v)={
   local(u,n);
   n=length(v);
   u=vector(n);
   u[1]=u0*v0-1;
   for(h=2,n,
      u[h]=u0*v[h-1]+v0*u[h-1];
      for(s=1,h-2,
          u[h]+=u[s]*v[h-1-s]
      );
      u[h]/=h
   );
   u
}

v_to_V(V0,v0,v)={
    local(s,n);
    n=length(v);
    s=array_to_taylor(v0,v);
    s=intformal(s);
    s=exp(s);
    s*=V0;
    taylor_to_array(s,n+1)[2]
}

fun_v(params, x)={
   local(r);
   if(x<0.25,
       r=use_fun(0.0,0.0,params[1],x),
   if(x<0.7,
       r=use_fun(params[2],0.5,params[3],x),
   if(x<1.4,
       r=use_fun(params[4],1.0,params[5],x),
   if(x<2.0,
       r=use_fun(params[6],1.7,params[7],x), 
   if(x<2.4,
       r=use_fun(params[8],2.2,params[9],x),
   if(x<2.8,
       r=use_fun(params[10],2.6,params[11],x),
   if(x<3.2,
       r=use_fun(params[12],3.0,params[13],x),
   if(x<3.8,
       r=use_fun(params[14],3.5,params[15],x),
   if(x<4.5,
       r=use_fun(params[16],4.2,params[17],x),
       r=use_fun(params[18],5.0,params[19],x)
   )))))))));
   r
}

fun_V(params, x)={
   local(r);
   if(x<0.25,
       r=use_fun(1.0,0.0,params[1],x),
   if(x<0.7,
       r=use_fun(params[2],0.5,params[3],x),
   if(x<1.4,
       r=use_fun(params[4],1.0,params[5],x),
   if(x<2.0,
       r=use_fun(params[6],1.7,params[7],x), 
   if(x<2.4,
       r=use_fun(params[8],2.2,params[9],x),
   if(x<2.8,
       r=use_fun(params[10],2.6,params[11],x),
   if(x<3.2,
       r=use_fun(params[12],3.0,params[13],x),
   if(x<3.8,
       r=use_fun(params[14],3.5,params[15],x),
   if(x<4.5,
       r=use_fun(params[16],4.2,params[17],x),
       r=use_fun(params[18],5.0,params[19],x)
   )))))))));
   r
}

fun_dV(params, x)={
   local(r);
   if(x<0.25,
       r=use_dfun(0.0,params[1],x),
   if(x<0.7,
       r=use_dfun(0.5,params[3],x),
   if(x<1.4,
       r=use_dfun(1.0,params[5],x),
   if(x<2.0,
       r=use_dfun(1.7,params[7],x), 
   if(x<2.4,
       r=use_dfun(2.2,params[9],x),
   if(x<2.8,
       r=use_dfun(2.6,params[11],x),
   if(x<3.2,
       r=use_dfun(3.0,params[13],x),
   if(x<3.8,
       r=use_dfun(3.5,params[15],x),
   if(x<4.5,
       r=use_dfun(4.2,params[17],x),
       r=use_dfun(5.0,params[19],x)
   )))))))));
   r
}

fun_u(params, x)={
   local(r);
   if(x<0.7,
       r=use_fun(params[1],0.5,params[2],x),
   if(x<1.4,
       r=use_fun(params[3],1.0,params[4],x),
   if(x<2.0,
       r=use_fun(params[5],1.7,params[6],x), 
   if(x<2.4,
       r=use_fun(params[7],2.2,params[8],x),
   if(x<2.8,
       r=use_fun(params[9],2.6,params[10],x),
   if(x<3.2,
       r=use_fun(params[11],3.0,params[12],x),
   if(x<3.8,
       r=use_fun(params[13],3.5,params[14],x),
   if(x<4.5,
       r=use_fun(params[15],4.2,params[16],x),
       r=use_fun(params[17],5.0,params[18],x)
   ))))))));
   r
}

fun_du(params, x)={
   local(r);
   if(x<0.7,
       r=use_dfun(0.5,params[2],x),
   if(x<1.4,
       r=use_dfun(1.0,params[4],x),
   if(x<2.0,
       r=use_dfun(1.7,params[6],x), 
   if(x<2.4,
       r=use_dfun(2.2,params[8],x),
   if(x<2.8,
       r=use_dfun(2.6,params[10],x),
   if(x<3.2,
       r=use_dfun(3.0,params[12],x),
   if(x<3.8,
       r=use_dfun(3.5,params[14],x),
   if(x<4.5,
       r=use_dfun(4.2,params[16],x),
       r=use_dfun(5.0,params[18],x)
   ))))))));
   r
}

delta(u_param,v_param,V_param,D_param,d)={
   local(sd,cd,td,u,v,V,D,du,dV,e);
   sd=sin(d);cd=cos(d);td=sd/cd;e=2*Pi-2*d;
   u=fun_u(u_param, e);V=fun_V(V_param,e);
   v=fun_v(v_param,e);D=fun_u(D_param,e);
   du=fun_du(u_param, e);dV=fun_dV(V_param,e);
   e*sd/cd^2-2*e*u*sqrt(v^2+1)-2*(td-u)*e*sqrt(v^2+1)+(V*(1/cd^2+2*du)+2*(td-u)*dV)/(V^2)*D
}

delta2(u_param,v_param,V_param,D_param,d)={
   local(sd,cd,td,u,v,V,D,du,dV,e);
   sd=sin(d);cd=cos(d);td=sd/cd;e=2*Pi-2*d;
   u=fun_u(u_param, e);V=fun_V(V_param,e);
   v=fun_v(v_param,e);D=fun_u(D_param,e);
   du=fun_du(u_param, e);dV=fun_dV(V_param,e);
   [e*sd/cd^2,-2*e*u*sqrt(v^2+1),-2*(td-u)*e*sqrt(v^2+1),+(V*(1/cd^2+2*du)+2*(td-u)*dV)/(V^2)*D]
}

fun_target(B_param,D_param,u_param,V_param, d)={
   local(sd,cd,td,u,e,s);
   e=2*Pi-2*d;sd=sin(d);cd=cos(d);td=sd/cd;
   s=log((1+sd)/(1-sd))+e/cd;
   s+=fun_u(B_param,e);
   s+=(td-fun_u(u_param,e))/fun_V(V_param,e)*fun_u(D_param,e);
   s
}

v=gen_v_params(500);
u=gen_u_params(v,0.590904891856688);
V=gen_V_params(v);
B=gen_B_params(v,u);
D=gen_D_params(v,V);